package com.izouma.awesomeadmin.web;

import java.util.*;
import org.apache.shiro.authz.annotation.RequiresAuthentication;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Controller;
import org.springframework.web.bind.annotation.*;
import com.izouma.awesomeadmin.constant.AppConstant;
import com.izouma.awesomeadmin.dto.Page;
import com.izouma.awesomeadmin.dto.Result;
import com.izouma.awesomeadmin.model.HousePart;
import com.izouma.awesomeadmin.service.HousePartService;

/**
*  controller类
*/
@Controller
@RequestMapping("/housePart")
public class HousePartController extends BaseController{

    @Autowired
    private HousePartService housePartService;

    /**
    * <p>获取全部记录。</p>
    */
    @RequiresAuthentication
    @RequestMapping(value = "/all", method = RequestMethod.GET)
    @ResponseBody
    public Result all(HousePart record) {
        List<HousePart> pp = housePartService.getHousePartList(record);
        return new Result(true, pp);
    }

    /**
    * <p>根据Id。</p>
    */
    @RequestMapping(value = "/getHousePart", method = RequestMethod.GET)
    @ResponseBody
    public Result getHousePart(@RequestParam(required = false, value = "id") String id) {
        HousePart data = housePartService.getHousePartById(id);
        return new Result(true, data);
    }

    /**
    * <p>根据条件获取。</p>
    */
    @RequestMapping(value = "/getOne", method = RequestMethod.GET)
    @ResponseBody
    public Result getOne(HousePart record) {
        HousePart data = housePartService.getHousePart(record);
        return new Result(true, data);
    }


    /**
    * <p>分页查询。</p>
    */
    @RequestMapping(value = "/page", method = RequestMethod.GET)
    @ResponseBody
    public Result page(Page page, HousePart record) {
        Map<String, Object> result = new HashMap<>();

        List<HousePart> pp =housePartService.getHousePartByPage(page, record);

        result.put(AppConstant.PAGE, page);
        result.put("pp", pp);
        return new Result(true, result);
    }


    /**
    * <p>保存。</p>
    */
    @RequestMapping(value = "/save", method = RequestMethod.POST)
    @ResponseBody
    public Result save(HousePart record) {
        boolean num = housePartService.createHousePart(record);
        if (num) {
        return new Result(true, record.getId());
        }
        return new Result(false, "保存异常");
    }

    /**
    * <p>更新信息。</p>
    */
    @RequestMapping(value = "/update", method = RequestMethod.POST)
    @ResponseBody
    public Result updateHousePart(HousePart record) {
        boolean num = housePartService.updateHousePart(record);
        if (num) {
        return new Result(true, "保存成功");
        }
        return new Result(false, "保存异常");
    }

    /**
    * <p>删除。</p>
    */
    @RequestMapping(value = "/del", method = RequestMethod.POST)
    @ResponseBody
    public Result deleteHousePart(@RequestParam(required = true, value = "id") String id) {

        boolean num = housePartService.deleteHousePart(id);
        if (num) {
        return new Result(true, "删除成功");
        }
        return new Result(false, "删除异常");
    }
}

